%define ocamlname markup

Name:           ocaml-%{ocamlname}
Version:        0.7.6
Release:        1%{?dist}.emp1
Summary:        Error-recovering functional HTML5 and XML parsers and writers
License:        BSD
URL:            https://github.com/aantron/markup.ml
Source0:        markup.ml-%{version}.tar.gz

Requires:  	ocaml >= 0.7.6
Requires:	ocaml-uchar
Requires:	ocaml-uutf >= 1.0.0
Requires:	ocaml-lwt

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 0.7.6
BuildRequires:  jbuilder
BuildRequires:	ocaml-uchar-devel
BuildRequires:	ocaml-uutf-devel >= 1.0.0
BuildRequires:	ocaml-lwt-devel
BuildRequires:	ocaml-ounit

%description
Markup.ml provides an HTML parser and an XML parser. The parsers are
wrapped in a simple interface: they are functions that transform byte
streams to parsing signal streams. Streams can be manipulated in
various ways, such as processing by fold, filter, and map, assembly
into DOM tree structures, or serialization back to HTML or XML.

Both parsers are based on their respective standards. The HTML parser,
in particular, is based on the state machines defined in HTML5.

The parsers are error-recovering by default, and accept
fragments. This makes it very easy to get a best-effort parse of some
input. The parsers can, however, be easily configured to be strict,
and to accept only full documents.

Apart from this, the parsers are streaming (do not build up a document
in memory), non-blocking (can be used with threading libraries), lazy
(do not consume input unless the signal stream is being read), and
process the input in a single pass. They automatically detect the
character encoding of the input stream, and convert everything to
UTF-8.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-uchar-devel
Requires:	ocaml-uutf-devel >= 1.0.0
Requires:	ocaml-lwt-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n markup.ml-%{version}

%build
ocaml src/configure.ml
jbuilder build -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install

%check
jbuilder runtest -p %{ocamlname} %{?_smp_mflags}

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
